Loading...
Searching...
No Matches
juce::UndoManager Class Reference

## Detailed Description

Manages a list of undo/redo commands.

An UndoManager object keeps a list of past actions and can use these actions to move backwards and forwards through an undo history.

To use it, create subclasses of UndoableAction which perform all the actions you need, then when you need to actually perform an action, create one and pass it to the UndoManager's perform() method.

The manager also uses the concept of 'transactions' to group the actions together - all actions performed between calls to beginNewTransaction() are grouped together and are all undone/redone as a group.

The UndoManager is a ChangeBroadcaster, so listeners can register to be told when actions are performed or undone.

See also
  UndoableAction

The documentation for this class was generated from the following file:

- juce_data_structures/undomanager/juce_UndoManager.h

Inheritance diagram for juce::UndoManager:

## Public Member Functions

| UndoManager (int maxNumberOfUnitsToKeep=30000, int minimumTransactionsToKeep=30)
| Creates an UndoManager.
| ~UndoManager () override
| Destructor.
void | clearUndoHistory ()
| Deletes all stored actions in the list.
int | getNumberOfUnitsTakenUpByStoredCommands () const
| Returns the current amount of space to use for storing UndoableAction objects.
void | setMaxNumberOfStoredUnits (int maxNumberOfUnitsToKeep, int minimumTransactionsToKeep)
| Sets the amount of space that can be used for storing UndoableAction objects.
bool | perform (UndoableAction *action)
| Performs an action and adds it to the undo history list.
bool | perform (UndoableAction *action, const String &actionName)
| Performs an action and also gives it a name.
void | beginNewTransaction ()
| Starts a new group of actions that together will be treated as a single transaction.
void | beginNewTransaction (const String &actionName)
| Starts a new group of actions that together will be treated as a single transaction.
void | setCurrentTransactionName (const String &newName)
| Changes the name stored for the current transaction.
String | getCurrentTransactionName () const
| Returns the name of the current transaction.
bool | canUndo () const
| Returns true if there's at least one action in the list to undo.
bool | undo ()
| Tries to roll-back the last transaction.
bool | undoCurrentTransactionOnly ()
| Tries to roll-back any actions that were added to the current transaction.
String | getUndoDescription () const
| Returns the name of the transaction that will be rolled-back when undo() is called.
StringArray | getUndoDescriptions () const
| Returns the names of the sequence of transactions that will be performed if undo() is repeatedly called.
Time | getTimeOfUndoTransaction () const
| Returns the time to which the state would be restored if undo() was to be called.
void | getActionsInCurrentTransaction (Array< const UndoableAction * > &actionsFound) const
| Returns a list of the UndoableAction objects that have been performed during the transaction that is currently open.
int | getNumActionsInCurrentTransaction () const
| Returns the number of UndoableAction objects that have been performed during the transaction that is currently open.
bool | canRedo () const
| Returns true if there's at least one action in the list to redo.
bool | redo ()
| Tries to redo the last transaction that was undone.
String | getRedoDescription () const
| Returns the name of the transaction that will be redone when redo() is called.
StringArray | getRedoDescriptions () const
| Returns the names of the sequence of transactions that will be performed if redo() is repeatedly called.
Time | getTimeOfRedoTransaction () const
| Returns the time to which the state would be restored if redo() was to be called.
bool | isPerformingUndoRedo () const
| Returns true if the caller code is in the middle of an undo or redo action.
Public Member Functions inherited from juce::ChangeBroadcaster
| ChangeBroadcaster () noexcept
| Creates an ChangeBroadcaster.
virtual | ~ChangeBroadcaster ()
| Destructor.
void | addChangeListener (ChangeListener *listener)
| Registers a listener to receive change callbacks from this broadcaster.
void | removeChangeListener (ChangeListener *listener)
| Unregisters a listener from the list.
void | removeAllChangeListeners ()
| Removes all listeners from the list.
void | sendChangeMessage ()
| Causes an asynchronous change message to be sent to all the registered listeners.
void | sendSynchronousChangeMessage ()
| Sends a synchronous change message to all the registered listeners.
void | dispatchPendingMessages ()
| If a change message has been sent but not yet dispatched, this will call sendSynchronousChangeMessage() to make the callback immediately.

## Constructors and Destructors

## UndoManager()

juce::UndoManager::UndoManager | ( | int | maxNumberOfUnitsToKeep = 30000,
|  | int | minimumTransactionsToKeep = 30 )

Creates an UndoManager.

Parameters

  maxNumberOfUnitsToKeep | each UndoableAction object returns a value to indicate how much storage it takes up (UndoableAction::getSizeInUnits()), so this lets you specify the maximum total number of units that the undomanager is allowed to keep in memory before letting the older actions drop off the end of the list.
  minimumTransactionsToKeep | this specifies the minimum number of transactions that will be kept, even if this involves exceeding the amount of space specified in maxNumberOfUnitsToKeep

Referenced by isPerformingUndoRedo().

## ~UndoManager()

juce::UndoManager::~UndoManager | ( |  | ) |

override

Destructor.

## Member Functions

## clearUndoHistory()

void juce::UndoManager::clearUndoHistory | ( |  | ) |

Deletes all stored actions in the list.

## getNumberOfUnitsTakenUpByStoredCommands()

int juce::UndoManager::getNumberOfUnitsTakenUpByStoredCommands | ( |  | ) | const

Returns the current amount of space to use for storing UndoableAction objects.

See also
  setMaxNumberOfStoredUnits

## setMaxNumberOfStoredUnits()

void juce::UndoManager::setMaxNumberOfStoredUnits | ( | int | maxNumberOfUnitsToKeep,
|  | int | minimumTransactionsToKeep )

Sets the amount of space that can be used for storing UndoableAction objects.

Parameters

  maxNumberOfUnitsToKeep | each UndoableAction object returns a value to indicate how much storage it takes up (UndoableAction::getSizeInUnits()), so this lets you specify the maximum total number of units that the undomanager is allowed to keep in memory before letting the older actions drop off the end of the list.
  minimumTransactionsToKeep | this specifies the minimum number of transactions that will be kept, even if this involves exceeding the amount of space specified in maxNumberOfUnitsToKeep

See also
  getNumberOfUnitsTakenUpByStoredCommands

## perform() [1/2]

bool juce::UndoManager::perform | ( | UndoableAction * | action | ) |

Performs an action and adds it to the undo history list.

Parameters

  action | the action to perform - this object will be deleted by the UndoManager when no longer needed

Returns
  true if the command succeeds - see UndoableAction::perform

See also
  beginNewTransaction

## perform() [2/2]

bool juce::UndoManager::perform | ( | UndoableAction * | action,
|  | const String & | actionName )

Performs an action and also gives it a name.

Parameters

  action | the action to perform - this object will be deleted by the UndoManager when no longer needed
  actionName | if this string is non-empty, the current transaction will be given this name; if it's empty, the current transaction name will be left unchanged. See setCurrentTransactionName()

Returns
  true if the command succeeds - see UndoableAction::perform

See also
  beginNewTransaction

## beginNewTransaction() [1/2]

void juce::UndoManager::beginNewTransaction | ( |  | ) |

Starts a new group of actions that together will be treated as a single transaction.

All actions that are passed to the perform() method between calls to this method are grouped together and undone/redone together by a single call to undo() or redo().

## beginNewTransaction() [2/2]

void juce::UndoManager::beginNewTransaction | ( | const String & | actionName | ) |

Starts a new group of actions that together will be treated as a single transaction.

All actions that are passed to the perform() method between calls to this method are grouped together and undone/redone together by a single call to undo() or redo().

Parameters

  actionName | a description of the transaction that is about to be performed

## setCurrentTransactionName()

void juce::UndoManager::setCurrentTransactionName | ( | const String & | newName | ) |

Changes the name stored for the current transaction.

Each transaction is given a name when the beginNewTransaction() method is called, but this can be used to change that name without starting a new transaction.

## getCurrentTransactionName()

String juce::UndoManager::getCurrentTransactionName | ( |  | ) | const

Returns the name of the current transaction.

See also
  setCurrentTransactionName

## canUndo()

bool juce::UndoManager::canUndo | ( |  | ) | const

Returns true if there's at least one action in the list to undo.

See also
  getUndoDescription, undo, canRedo

## undo()

bool juce::UndoManager::undo | ( |  | ) |

Tries to roll-back the last transaction.

Returns
  true if the transaction can be undone, and false if it fails, or if there aren't any transactions to undo

See also
  undoCurrentTransactionOnly

## undoCurrentTransactionOnly()

bool juce::UndoManager::undoCurrentTransactionOnly | ( |  | ) |

Tries to roll-back any actions that were added to the current transaction.

This will perform an undo() only if there are some actions in the undo list that were added after the last call to beginNewTransaction().

This is useful because it lets you call beginNewTransaction(), then perform an operation which may or may not actually perform some actions, and then call this method to get rid of any actions that might have been done without it rolling back the previous transaction if nothing was actually done.

Returns
  true if any actions were undone.

## getUndoDescription()

String juce::UndoManager::getUndoDescription | ( |  | ) | const

Returns the name of the transaction that will be rolled-back when undo() is called.

See also
  undo, canUndo, getUndoDescriptions

## getUndoDescriptions()

StringArray juce::UndoManager::getUndoDescriptions | ( |  | ) | const

Returns the names of the sequence of transactions that will be performed if undo() is repeatedly called.

Note that for transactions where no name was provided, the corresponding string will be empty.

See also
  undo, canUndo, getUndoDescription

## getTimeOfUndoTransaction()

Time juce::UndoManager::getTimeOfUndoTransaction | ( |  | ) | const

Returns the time to which the state would be restored if undo() was to be called.

If an undo isn't currently possible, it'll return Time().

## getActionsInCurrentTransaction()

void juce::UndoManager::getActionsInCurrentTransaction | ( | Array< const UndoableAction * > & | actionsFound | ) | const

Returns a list of the UndoableAction objects that have been performed during the transaction that is currently open.

Effectively, this is the list of actions that would be undone if undoCurrentTransactionOnly() were to be called now.

The first item in the list is the earliest action performed.

## getNumActionsInCurrentTransaction()

int juce::UndoManager::getNumActionsInCurrentTransaction | ( |  | ) | const

Returns the number of UndoableAction objects that have been performed during the transaction that is currently open.

See also
  getActionsInCurrentTransaction

## canRedo()

bool juce::UndoManager::canRedo | ( |  | ) | const

Returns true if there's at least one action in the list to redo.

See also
  getRedoDescription, redo, canUndo

## redo()

bool juce::UndoManager::redo | ( |  | ) |

Tries to redo the last transaction that was undone.

Returns
  true if the transaction can be redone, and false if it fails, or if there aren't any transactions to redo

## getRedoDescription()

String juce::UndoManager::getRedoDescription | ( |  | ) | const

Returns the name of the transaction that will be redone when redo() is called.

See also
  redo, canRedo, getRedoDescriptions

## getRedoDescriptions()

StringArray juce::UndoManager::getRedoDescriptions | ( |  | ) | const

Returns the names of the sequence of transactions that will be performed if redo() is repeatedly called.

Note that for transactions where no name was provided, the corresponding string will be empty.

See also
  redo, canRedo, getRedoDescription

## getTimeOfRedoTransaction()

Time juce::UndoManager::getTimeOfRedoTransaction | ( |  | ) | const

Returns the time to which the state would be restored if redo() was to be called.

If a redo isn't currently possible, it'll return Time::getCurrentTime().

See also
  redo, canRedo

## isPerformingUndoRedo()

bool juce::UndoManager::isPerformingUndoRedo | ( |  | ) | const

Returns true if the caller code is in the middle of an undo or redo action.

References UndoManager().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited